function custom_one_sample_T_test_gui()
%custom_one_sample_T_test_gui is the gui for
%custom_one_sample_T_test_programmatic.

%% GUI Initialization

f_ost = figure('Visible','on','MenuBar','none','Color',[0.94,0.94,0.94], ...
    'Units','normalized','OuterPosition',[0.25,0.2,0.5,0.6]);
uicontrol(f_ost,'Style','text','String','One Sample T-test', ...
    'FontUnits','normalized','FontSize',0.5,'Units','normalized', ...
    'Position',[0,0.9375,1,0.05]);
uicontrol(f_ost,'Style','text', ...
    'String','Choose the images to perfom the test on:', ...
    'FontUnits','normalized','FontSize',0.5,'Units','normalized', ...
    'Position',[0.025,0.8875,0.35,0.05]);
p_files = uipanel(f_ost,'BackgroundColor',[0.9,0.9,0.9], ...
    'Units','normalized','Position',[0.025,0.35,0.95,0.525]);
test_data = struct('test_name','','test_imgs',{{''}});
test_list = uicontrol(p_files,'Style','listbox', ...
    'String',test_data(1).test_name,'FontUnits','points','FontSize',12, ...
    'Enable','on','Units','normalized', ...
    'Position',[0.025,0.15,0.4625,0.825],'Callback',@load_img_paths);
uicontrol(p_files,'Style','pushbutton','String','Add Test', ...
    'FontUnits','normalized','FontSize',0.5,'Units','normalized', ...
    'Position',[0.025,0.025,0.4625/2,0.1],'Callback',@add_test);
uicontrol(p_files,'Style','pushbutton','String','Remove Test', ...
    'FontUnits','normalized','FontSize',0.5,'Units','normalized', ...
    'Position',[0.025+(0.4625/2),0.025,0.4625/2,0.1], ...
    'Callback',@remove_test);
file_list = uicontrol(p_files,'Style','listbox','FontUnits','points', ...
    'FontSize',12,'Enable','on','Units','normalized', ...
    'Position',[0.5125,0.15,0.4625,0.825]);
uicontrol(p_files,'Style','pushbutton','String','Add Folder', ...
    'FontUnits','normalized','FontSize',0.5,'Units','normalized', ...
    'Position',[0.5125,0.025,0.4625/3,0.1],'Callback',@add_folder);
uicontrol(p_files,'Style','pushbutton','String','Add Image', ...
    'FontUnits','normalized','FontSize',0.5,'Units','normalized', ...
    'Position',[0.5125+(0.4625/3),0.025,0.4625/3,0.1],'Callback',@add_image);
uicontrol(p_files,'Style','pushbutton','String','Remove', ...
    'FontUnits','normalized','FontSize',0.5,'Units','normalized', ...
    'Position',[0.5125+(2*0.4625/3),0.025,0.4625/3,0.1],'Callback',@remove);
uicontrol(f_ost,'Style','text','String','Overlap Map:', ...
    'FontUnits','normalized','FontSize',0.625,'Units','normalized', ...
    'Position',[0.025,0.275,0.29,0.04]);
dof_edit = uicontrol(f_ost,'Style','edit','FontUnits','normalized', ...
    'FontSize',0.5,'Units','normalized','Position',[0.32,0.275,0.58,0.05]);
uicontrol(f_ost,'Style','pushbutton','String','Browse', ...
    'FontUnits','normalized','FontSize',0.5,'Units','normalized', ...
    'Position',[0.905,0.275,0.07,0.05],'Callback',@file_browse);
uicontrol(f_ost,'Style','text','String','Test-Value:', ...
    'FontUnits','normalized','FontSize',0.625,'Units','normalized', ...
    'Position',[0.025,0.2,0.1,0.04]);
base_edit = uicontrol(f_ost,'Style','edit','String','0', ...
    'FontUnits','normalized','FontSize',0.5,'Units','normalized', ...
    'Position',[0.15,0.2,0.2,0.05],'Callback',@update_base);
uicontrol(f_ost,'Style','text','String','Minimum Subjects per Voxel:', ...
    'FontUnits','normalized','FontSize',0.625,'Units','normalized', ...
    'Position',[0.4,0.2,0.25,0.04]);
thresh_edit = uicontrol(f_ost,'Style','edit','FontUnits','normalized', ...
    'FontSize',0.5,'Units','normalized','Position',[0.655,0.2,0.2,0.05],'Callback',@update_thresh);
uicontrol(f_ost,'Style','text','String','Output Directory:', ...
    'FontUnits','normalized','FontSize',0.625,'Units','normalized', ...
    'Position',[0.025,0.125,0.14,0.04]);
output_edit = uicontrol(f_ost,'Style','edit','FontUnits','normalized', ...
    'FontSize',0.5,'Units','normalized','Position',[0.17,0.125,0.73,0.05]);
uicontrol(f_ost,'Style','pushbutton','String','Browse', ...
    'FontUnits','normalized','FontSize',0.5,'Units','normalized', ...
    'Position',[0.905,0.125,0.07,0.05],'Callback',{@browse,output_edit});
uicontrol(f_ost,'Style','pushbutton','String','Save Config', ...
    'FontUnits','normalized','FontSize',0.4,'Units','normalized', ...
    'Position',[0.15,0.025,0.2,0.075],'Callback',@save_config);
uicontrol(f_ost,'Style','pushbutton','String','Load Config', ...
    'FontUnits','normalized','FontSize',0.4,'Units','normalized', ...
    'Position',[0.40,0.025,0.2,0.075],'Callback',@load_config);
uicontrol(f_ost,'Style','pushbutton','String','Run', ...
    'FontUnits','normalized','FontSize',0.5,'Units','normalized', ...
    'Position',[0.65,0.025,0.2,0.075],'Callback',@run_custom_one_sample_t_test);
handles = guihandles(f_ost);
handles.test_data = test_data;
handles.overlap_map = get(dof_edit,'String');
handles.output_dir = get(output_edit,'String');
handles.test_val = get(base_edit,'String');
handles.thresh = get(thresh_edit,'String');
guidata(f_ost,handles)

%% Callbacks

    function load_img_paths(hObject,~)
        test_index = get(hObject,'Value');
        if ~isempty(test_index)
            handles = guidata(f_ost);
            test = handles.test_data(test_index,:);
            set(file_list,'String',test.test_imgs)
        end
    end

    function add_test(~,~)
        handles = guidata(f_ost);
        test_data_old = handles.test_data;
        f_at = figure('Visible','on','MenuBar','none','NumberTitle','off', ...
            'Color',[0.94,0.94,0.94],'Units','normalized', ...
            'OuterPosition',[0.45,0.4,0.1,0.15]);
        uicontrol(f_at,'Style','text','String','Test Name:', ...
            'FontUnits','normalized','FontSize',0.5,'Units','normalized', ...
            'Position',[0,0.65,1,0.3]);
        name_edit = uicontrol(f_at,'Style','edit','FontUnits','points', ...
            'FontSize',12,'Units','normalized','Position',[0.025,0.3,0.95,0.4]);
        uicontrol(f_at,'Style','pushbutton','String','Enter', ...
            'FontUnits','normalized','FontSize',0.5,'Units','normalized', ...
            'Position',[0.025,0.025,0.475,0.275],'Callback',@enter);
        uicontrol(f_at,'Style','pushbutton','String','Cancel', ...
            'FontUnits','normalized','FontSize',0.5,'Units','normalized', ...
            'Position',[0.5,0.025,0.475,0.275],'Callback',@cancel);
        function [test_data] = enter(~,~)
            new_test = get(name_edit,'String');
            if isempty(test_data_old(1).test_name)
                test_data = struct('test_name',new_test,'test_imgs',{{''}});
                handles.test_data = test_data;
                guidata(f_ost,handles)
            else
                test_data = [test_data_old; struct('test_name',new_test,'test_imgs',{{''}})];
                handles.test_data = test_data;
                guidata(f_ost,handles)
            end
            for ii = 1:size(test_data,1)
                if ii == 1
                    list_cell = cellstr(test_data(ii).test_name);
                else
                    list_cell = [list_cell;cellstr(test_data(ii).test_name)]; %#ok<AGROW>
                end
            end
            set(test_list,'Value',1);
            set(test_list,'String',list_cell);
            close(f_at)
        end
        function [test_data] = cancel(~,~)
            test_data = test_data_old;
            close(f_at)
        end
        test_data = test_data_old;
        handles.test_data = test_data;
        guidata(f_ost,handles);
    end

    function remove_test(~,~)
        tests = get(test_list,'String');
        handles = guidata(f_ost);
        test_data = handles.test_data;
        if ischar(tests)
            tests = cellstr(tests);
        end
        test_index = get(test_list,'Value');
        tests{test_index,1} = [];
        test_data(test_index,:) = [];
        if isempty(test_data)
            test_data = struct('test_name','','test_imgs',{{''}});
        end
        handles.test_data = test_data;
        guidata(f_ost,handles);
        tests(cellfun('isempty',tests)) = [];
        set(test_list,'String',tests);
        set(test_list,'Value',1);
    end

    function add_folder(~,~)
        test_index = get(test_list,'Value');
        test_name = get(test_list,'String');
        if ischar(test_name)
            test_name = cellstr(test_name);
        end
        test_name = test_name{test_index};
        if ~isempty(test_name)
            folder_name = uigetdir(pwd,'Choose a folder with only the images you want to test in it:');
            d = dir([folder_name '\*.nii']);
            d = struct2cell(d);
            d(2:end,:) = [];
            d = d';
            for dd = 1:size(d,1)
                d{dd} = [folder_name '\' d{dd}];
            end
            handles = guidata(f_ost);
            test = handles.test_data(test_index,:);
            if isempty(test.test_imgs{1})
                test.test_imgs = d;
            else
                test.test_imgs = [test.test_imgs;d];
            end
            handles.test_data(test_index,:) = test;
            guidata(f_ost,handles);
            set(file_list,'Value',1);
            set(file_list,'String',test.test_imgs);
        end
    end

    function add_image(~,~)
        test_index = get(test_list,'Value');
        test_name = get(test_list,'String');
        if ischar(test_name)
            test_name = cellstr(test_name);
        end
        test_name = test_name{test_index};
        if ~isempty(test_name)
            [fni,pni,~] = uigetfile('*.nii','Choose a file:');
            if fni ~= 0
                image = fullfile(pni,fni);
                handles = guidata(f_ost);
                test = handles.test_data(test_index,:);
                if isempty(test.test_imgs{1})
                    test.test_imgs = image;
                else
                    test.test_imgs = [test.test_imgs;image];
                end
                handles.test_data(test_index,:) = test;
                guidata(f_ost,handles);
                set(file_list,'String',test.test_imgs);
            end
        end
    end

    function remove(~,~)
        test_index = get(test_list,'Value');
        test_name = get(test_list,'String');
        if ischar(test_name)
            test_name = cellstr(test_name);
        end
        test_name = test_name{test_index};
        if ~isempty(test_name)
            handles = guidata(f_ost);
            test = handles.test_data(test_index,:);
            img_index = get(file_list,'Value');
            test.test_imgs(img_index) = [];
            if isempty(test.test_imgs)
                test.test_imgs = {''};
            end
            handles.test_data(test_index,:) = test;
            guidata(f_ost,handles);
            set(file_list,'String',test.test_imgs);
            set(file_list,'Value',1);
        end
    end

    function file_browse(~,~)
        [fnfb,pnfb,~] = uigetfile('*.nii','Choose the Degrees-Of-Freedom Map:');
        if fnfb ~= 0
            filefb = fullfile(pnfb,fnfb);
            set(dof_edit,'String',filefb);
            handles = guidata(f_ost);
            handles.overlap_map = filefb;
            guidata(f_ost,handles)
        end
    end

    function update_base(hObject,~)
        handles = guidata(f_ost);
        handles.test_val = get(hObject,'String');
        guidata(f_ost,handles);
    end

    function update_thresh(hObject,~)
        handles = guidata(f_ost);
        handles.thresh = get(hObject,'String');
        guidata(f_ost,handles);
    end

    function browse(~,~,edit_box)
        folder_name = uigetdir(pwd,'Choose or Create the output folder: ');
        if folder_name ~= 0
            set(edit_box,'String',folder_name)
            handles = guidata(f_ost);
            handles.output_dir = folder_name;
            guidata(f_ost,handles);
        end
    end

    function save_config(~,~)
        [fnsc,pnsc,~] = uiputfile('one_sample_t_test.mat','Save Configuration File:');
        if fnsc ~= 0
            handles = guidata(f_ost);
            tests_and_images = handles.test_data;
            overlap_map = handles.overlap_map;
            output_dir = handles.output_dir;
            test_val = handles.test_val;
            thresh = handles.thresh;
            filesc = fullfile(pnsc,fnsc);
            save(filesc,'tests_and_images','overlap_map','output_dir','test_val','thresh');
        end
    end

    function load_config(~,~)
        [fnlc,pnlc,~] = uigetfile('*.mat','Load Configuration File:');
        if fnlc ~= 0
            filelc = fullfile(pnlc,fnlc);
            config = load(filelc);
            handles = guidata(f_ost);
            handles.test_data = config.tests_and_images;
            data = handles.test_data;
            names = data(1).test_name;
            for tt = 2:size(data,1)
                names = [names;data(2).test_name];
            end
            set(test_list,'String',names);
            handles.overlap_map = config.overlap_map;
            set(dof_edit,'String',config.overlap_map);
            handles.output_dir = config.output_dir;
            set(output_edit,'String',config.output_dir);
            handles.test_val = config.test_val;
            set(base_edit,'String',config.test_val);
            handles.thresh = config.thresh;
            set(thresh_edit,'String',config.thresh);
            guidata(f_ost,handles);
        end
    end

    function run_custom_one_sample_t_test(~,~)
        handles = guidata(f_ost);
        data = handles.test_data;
        test_val = handles.test_val;
        if ischar(test_val)
            test_val = num2str(test_val);
        end
        overlap_map = handles.overlap_map;
        thresh = handles.thresh;
        if ischar(thresh)
            thresh = num2str(thresh);
        end
        output_dir = handles.output_dir;
        
        c = clock; c_str = [num2str(c(1)) '_' num2str(c(2)) '_' num2str(c(3)) '_' num2str(c(4)) '_' num2str(c(5)) '_igma_ost_config_autosave.mat'];
        save(c_str,'data','test_val','overlap_map','thresh','output_dir');
        
        output_dir = [output_dir '\'];
        for rr = 1:size(data,1)
            input_cell = data(rr).test_imgs;
            test_label = data(rr).test_name;
            prntstr1 = ['Starting T-test for ' test_label ' ... ... ... '];
            fprintf(prntstr1)
            custom_one_sample_T_test_programmatic(input_cell,test_val,overlap_map,thresh,output_dir,test_label);
            prntstr2 = ['Done.\nResults written to ' formatstr(output_dir) '\n'];
            fprintf(prntstr2)
        end
        close(f_ost)
    end
end