function imga()
%igma_gui is the central gui that links to the rest of the functions in
%this toolbox.

%% GUI Initialization
f_rva = figure('Visible','on','MenuBar','none','Color',[0.94,0.94,0.94],...
    'Units','normalized','OuterPosition',[0,0.2,0.25,0.6]);

uicontrol(f_rva,'Style','text', ...
    'String','Individually-Masked Group Analysis Pipeline', ...
    'FontUnits','normalized','FontSize',0.4,'Units','normalized', ...
    'Position',[0,0.9,1,0.1]);

p_main = uipanel(f_rva,'BackgroundColor',[0.9,0.9,0.9], ... 
    'Title','Main Functions','TitlePosition','centertop', ...
    'FontUnits','normalized','FontSize',0.1,'Units','normalized', ... 
    'Position',[0.025,0.4625,0.95,0.4125]);
uicontrol(p_main,'Style','pushbutton','String','Masking and Smoothing', ...
    'FontUnits','normalized','FontSize',0.3,'Units','normalized', ...
    'Position',[0.025,0.5125,0.95,0.4625], ...
    'Callback',@mask_and_smooth_button);
uicontrol(p_main,'Style','pushbutton','String','One Sample T Test', ... 
    'FontUnits','normalized','FontSize',0.3,'Units','normalized', ...
    'Position',[0.025,0.025,0.95,0.4625], ...
    'Callback',@one_sample_t_test_button);

p_subs = uipanel(f_rva,'BackgroundColor',[0.9,0.9,0.9], ...
    'Title','Sub-functions','TitlePosition','centertop', ...
    'FontUnits','normalized','FontSize',0.1,'Units','normalized', ...
    'Position',[0.025,0.025,0.95,0.4125]);
uicontrol(p_subs,'Style','pushbutton','String','Create Subject Masks', ...
    'FontUnits','normalized','FontSize',0.4,'Units','normalized', ...
    'Position',[0.025,(4/5)+0.025,0.95,(0.95/5)], ...
    'Callback',@create_subject_mask_button);
uicontrol(p_subs,'Style','pushbutton', ... 
    'String','Apply Masks to Subjects','FontUnits','normalized', ... 
    'FontSize',0.4,'Units','normalized', ...
    'Position',[0.025,(3/5)+0.025,0.95,(0.95/5)], ...
    'Callback',@apply_masks_to_subjects_button);
uicontrol(p_subs,'Style','pushbutton','String','Convert Zeros to NaNs', ...
    'FontUnits','normalized','FontSize',0.4,'Units','normalized', ...
    'Position',[0.025,(2/5)+0.025,0.95,(0.95/5)], ...
    'Callback',@switch_to_NaN_button);
uicontrol(p_subs,'Style','pushbutton','String','Convert NaNs to Zeros', ...
    'FontUnits','normalized','FontSize',0.4,'Units','normalized', ...
    'Position',[0.025,(1/5)+0.025,0.95,(0.95/5)], ...
    'Callback',@switch_to_Zero_button);
uicontrol(p_subs,'Style','pushbutton','String','Smooth', ...
    'FontUnits','normalized','FontSize',0.4,'Units','normalized', ...
    'Position',[0.025,0.025,0.95,(0.95/5)],'Callback',@smooth_button);
%% Callbacks

    function mask_and_smooth_button(~,~)
        mask_and_smooth_gui();
    end

    function one_sample_t_test_button(~,~)
        custom_one_sample_T_test_gui();
    end

    function create_subject_mask_button(~,~)
        create_mask_gui();
    end

    function apply_masks_to_subjects_button(~,~)
        apply_mask_gui();
    end

    function switch_to_NaN_button(~,~)
        switch_to_NaN_gui();
    end

    function switch_to_Zero_button(~,~)
        switch_to_Zero_gui();
    end

    function smooth_button(~,~)
        smooth_gui();
    end

end