function [] = switch_to_NaN(subj_cell,func_cell,output_dir)
%switch_to_NaN changes zero valued voxels to be NaN valued in order to
%prepare the image for smoothing with spm_smooth using an implicit mask.
%This should be used on images with a floating point number datatype, not
%images with an integer datatype.
%
%Inputs:
%   subj_cell   =   an Nx1 cell array holding the subject ids of N subjects
%   func_cell   =   an Nx1 cell array holding the paths to the functional
%                   images for this to be applied to
%   output_dir  =   the name of the output directory

subs = size(func_cell);
for ss = 1:subs
    fV = spm_vol(func_cell{ss});
    for vv = size(fV,1)
       fVn = fV(vv);
       fVol = spm_read_vols(fVn);
       fVol(fVol==0) = NaN;
       fVn.fname = [output_dir '\NaN_' subj_cell{ss} '.nii'];
       fVn = rmfield(fvn,'pinfo');
       spm_write_vol(fVn,fVol);
    end
end

end