function [] = switch_to_Zero(funcPathCell,outputDirCell,subjCell)
%switch_to_Zero changes NaN valued voxels to be zero valued in order to
%prepare it for preprocessing methods other than spm_smooth. This should be
%used on images that have had switch_to_NaN applied to them and been
%smoothed with an implicit mask using spm_smooth
%
%Inputs:
%   subj_cell   =   an Nx1 cell array holding the subject ids of N subjects
%   func_cell   =   an Nx1 cell array holding the paths to the functional
%                   images for this to be applied to
%   output_dir  =   the name of the output directory

subs = size(funcPathCell);
for ss = 1:subs
    fV = spm_vol(funcPathCell{ss});
    for vv = size(fV,1)
       fVn = fV(vv);
       fVol = spm_read_vols(fVn);
       fVol(isnan(fVol)) = 0;
       fVn.fname = [outputDirCell '\Zero_' subjCell{ss} '.nii'];
       fVn = rmfield(fvn,'pinfo');
       spm_write_vol(fVn,fVol);
    end
end
end